unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX, IniFiles;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_ShuttleClothSCList, U_PlanCardList, U_ShuttleClothJGList,
  U_ProductOrderLBNameSet, U_ShuttleClothGYList, U_JZSLMXLIST;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmShuttleClothSCListLR, frmShuttleClothSCListGL, frmShuttleClothSCListCX: TfrmShuttleClothSCList;
  frmShuttleClothJGList: TfrmShuttleClothJGList;
  frmPlanCardList: TfrmPlanCardList;
  frmShuttleClothGYListGL: TfrmShuttleClothGYList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);
  if Trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
    dtbase := 'chenfengdata';
    user := 'rtsa';
    pswd := 'rightsoft@5740';
//  server := '.';
//  dtbase := 'yiduidata';
//  user := 'sa';
//  pswd := 'rightsoft';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    1:  //织造工艺单录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '工艺单录入' then
          begin
            BringWindowToTop(frmShuttleClothGYListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmShuttleClothGYListGL := TfrmShuttleClothGYList.Create(application.MainForm);
          with frmShuttleClothGYListGL do
          begin
            Title := '工艺单录入';
            caption := Trim(Title);
            canshu1 := '录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShuttleClothGYListGL.BringToFront;
       //句柄
        mnewHandle := frmShuttleClothGYListGL.Handle;
      end;
    111:  //梭织织造单录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '织造单录入' then
          begin
            BringWindowToTop(frmShuttleClothSCListLR.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmShuttleClothSCListLR := TfrmShuttleClothSCList.Create(application.MainForm);
          with frmShuttleClothSCListLR do
          begin
            Title := '织造单录入';
            caption := Trim(Title);
            canshu1 := '录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShuttleClothSCListLR.BringToFront;
       //句柄
        mnewHandle := frmShuttleClothSCListLR.Handle;
      end;
    112:  //梭织织造单管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '织造单管理' then
          begin
            BringWindowToTop(frmShuttleClothSCListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmShuttleClothSCListGL := TfrmShuttleClothSCList.Create(application.MainForm);
          with frmShuttleClothSCListGL do
          begin
            Title := '织造单管理';
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShuttleClothSCListGL.BringToFront;
       //句柄
        mnewHandle := frmShuttleClothSCListGL.Handle;
      end;
    113:  //梭织织造单查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '织造单查询' then
          begin
            BringWindowToTop(frmShuttleClothSCListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmShuttleClothSCListCX := TfrmShuttleClothSCList.Create(application.MainForm);
          with frmShuttleClothSCListCX do
          begin
            Title := '织造单查询';
            caption := Trim(Title);
            canshu1 := '查询';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShuttleClothSCListCX.BringToFront;
       //句柄
        mnewHandle := frmShuttleClothSCListCX.Handle;
      end;

    211:  //经轴计划
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '经轴计划' then
          begin
            BringWindowToTop(frmPlanCardList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPlanCardList := TfrmPlanCardList.Create(application.MainForm);
          with frmPlanCardList do
          begin
            Title := '经轴计划';
            caption := Trim(Title);
            canshu1 := '录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
          end;
        end
        else
          frmPlanCardList.BringToFront;
       //句柄
        mnewHandle := frmPlanCardList.Handle;
      end;
    212:  //经规格管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '经规格管理' then
          begin
            BringWindowToTop(frmShuttleClothJGList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmShuttleClothJGList := TfrmShuttleClothJGList.Create(application.MainForm);
          with frmShuttleClothJGList do
          begin
            Title := '经规格管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
          end;
        end
        else
          frmShuttleClothJGList.BringToFront;
       //句柄
        mnewHandle := frmShuttleClothJGList.Handle;
      end;
    311:  //标签皮重设置
      begin

        if frmProductOrderLBNameSet = nil then
        begin
          frmProductOrderLBNameSet := TfrmProductOrderLBNameSet.Create(application.MainForm);
          with frmProductOrderLBNameSet do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmProductOrderLBNameSet.BringToFront;
       //句柄
        mnewHandle := frmProductOrderLBNameSet.Handle;
      end;

    411:  //   缩率明细统计表
      begin

        if frmJZSLMXLIST = nil then
        begin
          frmJZSLMXLIST := TfrmJZSLMXLIST.Create(application.MainForm);
          with frmJZSLMXLIST do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJZSLMXLIST.BringToFront;
       //句柄
        mnewHandle := frmJZSLMXLIST.Handle;
      end;
  end;

  Result := mnewHandle;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_ShuttleSchedule) then
    DataLink_ShuttleSchedule := TDataLink_ShuttleSchedule.Create(Application);
  try
    with DataLink_ShuttleSchedule.ADOLink do
    begin
      if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_ShuttleSchedule.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

